unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, math;

const radius = 4; // 

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Image1: TImage;
    Button1: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
    procedure DrawNodes;
  end;

  expoint = record
   x,y:extended;
   i,j:cardinal; // x y  
  end;

var
  Form1: TForm1;
  mas: array of expoint;  //  
  N:integer;
  f:TextFile;
  TEK: array of integer; //      
  Vh: array of integer; //      
  minL: extended; //     
  t1,t2,t3:int64;

implementation

{$R *.dfm}

function Doedin(x:extended):integer; // 
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48)and(byte(key)<>8))or(byte(key)>57)then key:=#0;
end;

procedure bres_circle(xc,yc,r:integer; col:tcolor=clblack); // Bresenham's (Pitteway and van Aken) algorithm
 var a,b,d:integer;
 procedure sim(x,y:integer);
 begin
  form1.Image1.Canvas.Pixels[xc+x,yc+y]:=col;
  form1.Image1.Canvas.Pixels[xc+x,yc-y]:=col;
  form1.Image1.Canvas.Pixels[xc-x,yc+y]:=col;
  form1.Image1.Canvas.Pixels[xc-x,yc-y]:=col;
  form1.Image1.Canvas.Pixels[xc+y,yc+x]:=col;
  form1.Image1.Canvas.Pixels[xc+y,yc-x]:=col;
  form1.Image1.Canvas.Pixels[xc-y,yc+x]:=col;
  form1.Image1.Canvas.Pixels[xc-y,yc-x]:=col;
 end;
begin
 a:=0;
 b:=r;
 d:=3-2*b;
 while(a<=b) do begin
  sim(a,b);
  if d<0 then d:=d+4*a+8
  else begin
   d:=d+4*(a-b)+10;
   dec(b);
  end;
  inc(a)
 end;
end;

function IsIntersection(x1,y1,x2,y2,x3,y3,x4,y4:extended):boolean;  // 
begin
 result:=(((x4-x3)*(y1-y3)-(y4-y3)*(x1-x3))*((x4-x3)*(y2-y3)-(y4-y3)*(x2-x3))<0) and
         (((x2-x1)*(y3-y1)-(y2-y1)*(x3-x1))*((x2-x1)*(y4-y1)-(y2-y1)*(x4-x1))<0);
end;

function Dlina(i,j:integer):extended;
 var x,y:extended;
begin
 x:=mas[i].x-mas[j].x;
 y:=mas[i].y-mas[j].y;
 result:=sqrt(x*x+y*y);
end;

procedure Combi(Arc: array of integer; Len: extended; K:integer);
 var Ac:array of integer; l: extended; i,z,j: integer; trig:boolean;
begin
 if K=N-3 then begin   //K -  ,   -    Arc 1  
 //       (     ,    )
  l:=Dlina(Vh[K],Arc[0])+Dlina(Arc[0],Vh[K+2]);
  if (l+Len)<minL then begin
   minL:=l+Len;
 //  CopyMemory(pointer(integer(TEK)),pointer(integer(Vh)),4*N);
   for i:=1 to N-3 do TEK[i]:=Vh[i]; //     ,     
   TEK[K+1]:=Arc[0];
  end;
  exit; //     ,    
 end else begin  //       
  setlength(Ac,length(Arc)-1); //        1 (     K  N)
  for i:=0 to high(Arc) do begin //       
   l:=Len+Dlina(Vh[K],Arc[i]);
   if l>=minL then continue; // ,          -    

   trig:=false;
   for j:=0 to K-1 do
    if IsIntersection(mas[Vh[j]].x,mas[Vh[j]].y,mas[Vh[j+1]].x,mas[Vh[j+1]].y,
                      mas[Vh[K]].x,mas[Vh[K]].y,mas[Arc[i]].x, mas[Arc[i]].y) then begin
     trig:=true;
     break;
    end;                  
   if trig then continue; //               

   j:=0;
   for z:=0 to high(Arc) do  //    
    if i<>z then begin
     Ac[j]:=Arc[z];
     inc(j);
    end;
   z:=K+1;
   Vh[z]:=Arc[i]; //       
   Combi(Ac,l,z);  //    
  end;
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);    //       (   )
 var i:integer;
 arc:array of integer;
begin
 if (mas=nil) or (N<3) then exit;
 TEK:=nil;
 Vh:=nil;
 setlength(TEK,N);
 setlength(Vh,N);
 TEK[0]:=0;       //   ,        
 TEK[N-1]:=N-1;
 Vh[0]:=0;
 Vh[N-1]:=N-1;
 minL:=infinity;
 setlength(arc,N-2);
 for i:=0 to N-3 do arc[i]:=i+1;

queryperformancecounter(t1);
 Combi(arc,0,0);
queryperformancecounter(t2);
queryperformancefrequency(t3);

 for i:=0 to N-2 do begin
  image1.Canvas.MoveTo(mas[TEK[i]].i, mas[TEK[i]].j);
  image1.Canvas.LineTo(mas[TEK[i+1]].i, mas[TEK[i+1]].j);
 end;

 form1.Caption:=floattostr((t2-t1)/t3)+'   '+floattostr(minL/image1.Width); //   
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 image1.Canvas.Brush.Color:=clwhite;
 image1.Canvas.fillrect(image1.Canvas.cliprect);
 doublebuffered:=true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
 var i:integer;
 s:string;
begin
 if savedialog1.Execute then begin
  AssignFile(f, savedialog1.FileName);
  Rewrite(f);
  try
   for i:=0 to n-1 do begin
    s:=floattostr(mas[i].x)+' '+floattostr(mas[i].y);
    WriteLn(f,s);
   end;
  finally
   CloseFile(f);
  end;
 end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
 var s:string;
 var i:integer;
begin
 if opendialog1.Execute then begin
  AssignFile(f, opendialog1.FileName);
  Reset(f);
  mas:=nil;
  s:='';
  N:=0;
  try
   while eof(f)=false do begin
    readln(f,s);
    if s<>'' then begin
     inc(N);
     setlength(mas,N);
     i:=pos(' ',s);
     mas[N-1].x:=strtofloat(copy(s,1,i));
     mas[N-1].y:=strtofloat(copy(s,i+1,length(s)-i));
     mas[N-1].i:=doedin(mas[N-1].x);
     mas[N-1].j:=doedin(mas[N-1].y);
    end;
   end; 
  finally
   CloseFile(f);
  end;
  if mas<>nil then begin
   DrawNodes;
   speedbutton1.Enabled:=true; //   
   button1.Enabled:=true;
   edit1.Text:=inttostr(N);
  end; 
 end;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var i:integer;
begin
 if key=13 then begin
  if edit1.Text='' then exit;
  N:=strtoint(edit1.Text);
  mas:=nil;
  setlength(mas,N);
  randomize;
  for i:=0 to N-1 do begin
   mas[i].x:=doedin(10000*(radius*2+random*(image1.Width-radius*4)))/10000;
   mas[i].y:=doedin(10000*(radius*2+random*(image1.Height-radius*4)))/10000;
   mas[i].i:=doedin(mas[i].x);
   mas[i].j:=doedin(mas[i].y);
  end;
  DrawNodes;
  speedbutton1.Enabled:=true; //   
  button1.Enabled:=true;
 end;
end;

procedure TForm1.DrawNodes;
 var i:integer;
begin
 image1.Canvas.fillrect(image1.Canvas.cliprect);
 for i:=0 to N-1 do begin
  bres_circle(mas[i].i,mas[i].j,radius);
 end;

 bres_circle(mas[0].i,mas[0].j,radius-1,clred);   //  ( 0)           
 bres_circle(mas[0].i,mas[0].j,radius-2,clred);
 bres_circle(mas[0].i,mas[0].j,radius-3,clred);

 bres_circle(mas[N-1].i,mas[N-1].j,radius-1,clblue); //    
 bres_circle(mas[N-1].i,mas[N-1].j,radius-2,clblue);
 bres_circle(mas[N-1].i,mas[N-1].j,radius-3,clblue);
end;

end.
